#!/usr/bin/perl

$REVISION = '$Id: testRdfParser.pl,v 1.27 1999/12/11 20:28:22 eric Exp $ ';

use strict;

BEGIN {unshift@INC,('../../..');}
use W3C::Rdf::RdfApp;
package testRdfParser;
@testRdfParser::ISA = qw(W3C::Rdf::RdfApp);

my $tester = new testRdfParser;
$tester->execute(\@ARGV);
if ($@) {
    die $@.' at line '.$tester->{XML_PARSER}->getLineNumber.' column '.$tester->{XML_PARSER}->getColumnNumber;
}

sub render {
    my ($self) = @_;
    my @attribs = $self->{RDF_PARSER}->getRootAttribution;
    my $sysID = $self->{RDF_PARSER}->getSystemId;
    my ($query, @lookFors);

    # give $self->{RDF_PARSER} as a W3C::SAX::NamespaceHandler to unmap names.
    print join ("\n", $self->{RDF_DB}->expandStatements(undef, ':', $self->{NAMESPACE_HANDLER}, 
							{-attributions => \@attribs, -sourceOnly => $self->{ARGS}{-sourceOnly}}));
    print "\n--------end of triples--------\n";

    # exercise some query functions in the W3C::Rdf::RdfDB
    @lookFors = ('http://www.w3.org/schema/certHTMLv1/access', 
		 'http://www.w3.org/schema/certHTMLv1/accessor', 
		 'http://www.w3.org/schema/certHTMLv1/hasAccessTo') if (!@lookFors);
    my @copy = @lookFors;
    my @a = map {\$_} @copy;
    $self->{RDF_DB}->absoluteLink($sysID, @a);
    my $type = 'http://www.w3.org/schema/certHTMLv1/resourceAccessRule';
    $self->{RDF_DB}->absoluteLink($sysID, \$type);
    my @nodes = $self->{RDF_DB}->nodesWithType(undef, $type, {-attributions => \@attribs});
    my @nodes1 = $self->{RDF_DB}->allPredicates(undef, \@copy);
#    $query = "(ask '((http://www.w3.org/schema/certHTMLv1/access ?x \"acc1\") 
#    $query = "(ask '((http://www.w3.org/schema/certHTMLv1/access ?x ?z) 
#(?y ?x \"http://user1\"))
#:collect ?x)" if (!$query);
    # (ask '((http://www.w3.org/schema/certHTMLv1/hasAccessTo ?s ?t) (http://www.w3.org/schema/certHTMLv1/accessor ?s ?r) (http://www.w3.org/schema/certHTMLv1/access ?s ?a)) :collect '(?s ?t ?r ?a))
    $query = "(ask '((http://t.t/p1 ?s1 ?o1) (http://t.t/p2 ?o1 ?o2) (?o3 ?o2 ?o3) (http://t.t/p4 ?s1 ?o2)) :collect '(?s1 ?o3))";
    my ($nodes2, $selects, $messages) = $self->{RDF_DB}->algernon($query, $sysID);

    print join ("\n", @$messages);
    print 'algernon "'.$query.'" -> '.join ("\n", map {'('.join (' ', map {$_->show} @$_).')'} @$nodes2)."\n";

    # find all defined recombinations of the objects of the nodes
    my @join = $self->{RDF_DB}->join(undef, \@nodes, \@copy);

    # show the onces we got
    foreach my $element (@join) {
	for (my $i = $0; $i <= $#lookFors; $i++) {
	    eval {print $lookFors[$i].': '.$element->[$i]->show.'  ';};
	}
	print "\n";
    }

    # demonstrate the anySubjects function
#    my @supplied = $self->{RDF_DB}->supplied;
#    my @theirStatements = $self->{RDF_DB}->anySubjects(\@supplied, [$inputSource->getPublicId]);
#    foreach my $triple (@theirStatements) {
#	print $triple->show."\n";
#    }

    # test the anyContainerNodes function to make sure the acl stuff keeps working
    foreach my $node (@nodes) {
	my $lookForPredicate = 'http://www.w3.org/schema/certHTMLv1/hasAccessTo';
	$self->{RDF_DB}->absoluteLink($sysID, \$lookForPredicate);
	my @resourceList = $self->{RDF_DB}->triplesMatching(undef, [[$lookForPredicate, $node, undef]]);
	my @resources = map {$_->getObject} @resourceList;
	my @t = $self->{RDF_DB}->anyContainerNodes(undef, [$node]);
	map {print "\$aclDB->addResourceAttribute(['".join('\',\'', map {$_->show} @resources)."'], {'aclBinBag', ".$_->getSubject->show."})\n"} @t;
    }

    return;
}

sub main::break {
    print 'break: '.join (' ', @_)."\n";
    return;
}

